#！/usr/bin/env python
#-*- conding:utf-8 -*-
import tornado.web
import tornado.ioloop
import tornado.websocket



class ChatHandle(tornado.web.RequestHandler):
    def get(self,*args, **kwargs):
        self.render('index.html')


class MessageHandle(tornado.websocket.WebSocketHandler):
    client_list = set()
    def open(self, *args, **kwargs):
        '''
        创建链接时触发
        :param args:
        :param kwargs:
        :return:
        '''
        self.client_list.add(self)

    def on_message(self, message):
        '''
        消息交互时触发
        :param message:
        :return:
        '''
        content = self.render_string('send_mes.html',mes=message)
        for obj in self.client_list:
            if obj == self:
                pass
            else:
                obj.write_message(content)

    def on_close(self):
        '''
        关闭链接时触发
        :return:
        '''
        self.client_list.remove(self)

def run():
    settings={
        'static_path':'static',
        'template_path':'templates',
    }
    application = tornado.web.Application([       #路由分发
        ('/index',ChatHandle,),
        ('/message',MessageHandle),
    ],**settings)
    application.listen(8888)
    tornado.ioloop.IOLoop.instance().start()








if __name__ == '__main__':
    run()